<?php
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: MAMS (c) 2020-2021 by CMS Made Simple Foundation
#  An add-on module for CMS Made Simple to provide useful functions
#  and commonly used gui capabilities to other modules.
#-------------------------------------------------------------------------
# A fork of:
#
# Module: FrontEndUsers (c) 2008-2014 by Robert Campbell
#         (calguy1000@cmsmadesimple.org)
#
#-------------------------------------------------------------------------
#
# CMSMS - CMS Made Simple is (c) 2006 - 2021 by CMS Made Simple Foundation
# CMSMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# Visit the CMSMS Homepage at: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE
if( !defined('CMS_VERSION') ) { exit; }

$uid = $this->LoggedInId();
if( $uid < 1 ) return;
$username = $this->LoggedInName();
$this->Logout();

audit( '', $this->GetName(), "$username logged out");

$parms = [];
$parms['username'] = $username;
$parms['id'] = $uid;

// we're logged out
// redirect somewhere
if( ($returnto = \xt_param::get_string($params,'returnto')) ) {
    $pageid = $this->resolve_alias_or_id($returnto);
    if( $pageid ) $this->RedirectContent($pageid);
}
if( ($url = $this->GetPostLoginURL()) ) {
    redirect($url);
}
else if( ($tplstr = $this->GetPreference('pageid_logout')) ) {
    $tpl = $smarty->CreateTemplate('string:'.$tplstr);
    $groups = $this->GetMemberGroupsArray( $uid );
    $groupname = $this->GetGroupName( $groups[0]['groupid'] );
    $tpl->assign('username',$username);
    $tpl->assign('group',$groupname);
    $tmp = $tpl->fetch();
    if( $tmp ) {
        $pageid = $this->resolve_alias_or_id($tmp);
        if( $pageid ) $this->RedirectContent($pageid);
    }
}
// all else fails, redirect back to our curren page.
$this->RedirectContent($returnid);
